1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX7 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX7_TASK':TURBO_taskn 'Ex7 v1.03':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark Ex7_bas v1.03
1090 REMark 18 OCT 08
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250 REMark                            **************************************
1260 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1270 REMark                            **************************************
1280 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1290 REMark ************************************************************
1300 REMark * We must set a primary window here if this is COMPILED .  *
1310 REMark * (PRPOS can be thought of as PRimary POSitioned)          *
1320 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1330 REMark * the window here must instead be "pulled down".           *
1340 REMark ************************************************************
1350 :
1360 REMark *******************************************************
1370 REMark * This is the repeat loop for reading the pointer and *
1380 REMark * taking appropriate action                           *
1390 REMark *******************************************************
1400 :
1410 REPeat lp
1420  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1430  r=255&&get_x%(k)
1440  SELect ON r
1450   =255:REMark loose items
1460     IF do_loose%(get_y%(k)):EXIT lp
1470   =254:REMark event
1480     IF do_event%(get_y%(k)):EXIT lp
1490   =REMAINDER :REMark application window k
1500     do_app r,get_y%(k)
1510  END SELect
1520 END REPeat lp
1530 STOP
1540 :
1550 DEFine PROCedure finish
1560  BUNST wwd:CLOS chid:REMark *  the window is removed *
1570  BRECHP:REMark *  all ALCHPd space returned to the heap *
1580 END DEFine
1590 :
1600 DEFine FuNction do_loose%(num)
1610  REMark *********************************************
1620  REMark * routine to do loose items                 *
1630  REMark * this returns 1 for "finished" else 0      *
1640  REMark * the three loose items are 0 = move sprite *
1650  REMark *                           1 = ESC         *
1660  REMark *                           2 = Second      *
1670  REMark *********************************************
1680  LOCal ov%
1690  ov%=0
1700  SELect ON num
1710   =1:finish:ov%=1
1720   =0:mve1
1730   =2:new_win
1740  END SELect
1750 :
1760  REMark *******************************************
1770  REMark *  D_LDRW  sets loose items to available  *
1780  REMark *******************************************
1790 :
1800  IF num<>1:D_LDRW num,wwd
1810  RETurn ov%
1820 END DEFine
1830 :
1840 DEFine FuNction do_event%(num%)
1850  REMark carry out event
1860  REMark only move and escape
1870  LOCal ov%
1880  ov%=0
1890  IF 2&&num%:finish:ov%=1
1900  IF 8&&num%:mve1
1910  RETurn ov%
1920 END DEFine
1930 :
1940 DEFine PROCedure do_app(wind%,num%)
1950  REMark *********************************
1960  REMark * to do the menu item no num%   *
1970  REMark * in window number wind%        *
1980  REMark * no action need be taken here  *
1990  REMark *********************************
2000 :
2010 END DEFine
2020 :
2030 DEFine PROCedure mve1
2040  REMark to move window
2050  BCHWIN wwd
2060 END DEFine
2070 :
2080 DEFine PROCedure new_win
2090 :
2100  REMark ****************************************
2110  REMark * to pull down a secondary window . .  *
2120  REMark * . . whose wdef is wd(1)              *
2130  REMark ****************************************
2140 :
2150                            REMark *********************************************
2160  wwd1=M_SETUP(#0,wd(1),-1):REMark * Set the working definition.               *
2170  chid1=M_PULLD(wwd1,-1):   REMark * Make the window appear.                   *
2180  do_sec:                   REMark * Process this window until . .             *
2190  BUNST wwd1:               REMark * it disappears . .                         *
2200  CLOS chid1:               REMark * . . and its channel is closed.            *
2210  BRCHP wwd1:               REMark * Returns the space for working definition. *
2220                            REMark *********************************************
2230 :
2240 END DEFine
2250 :
2260 DEFine PROCedure do_sec
2270  LOCal lp
2280  REPeat lp
2290   k=WRPTR(wwd1):REMark k indicates whether loose item, event or application
2300   r=255&&get_x%(k)
2310   SELect ON r
2320    =255:REMark loose items
2330      IF do_loose1%(get_y%(k)):EXIT lp
2340    =REMAINDER :REMark application window k
2350      do_app r,get_y%(k)
2360   END SELect
2370  END REPeat lp
2380 END DEFine
2390 :
2400 DEFine FuNction do_loose1%(num)
2410  LOCal ov%
2420  ov%=0
2430  SELect ON num
2440   =0:mve2
2450   =1:do_size
2460   =2:ov%=1
2470  END SELect
2480  D_LDRW num,wwd1
2490  RETurn ov%
2500 END DEFine
2510 :
2520 DEFine PROCedure mve2
2530  REMark to move window
2540  BCHWIN wwd1
2550 END DEFine
2560 :
2570 DEFine PROCedure do_size
2580  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2590  REMark ************************************************
2600  REMark * optr is the value to be used for PULLD.      *
2610  REMark * It is the current window position plus its   *
2620  REMark * "origin" plus its height. This will keep the *
2630  REMark * bottom left of the window in the same place  *
2640  REMark * as far as possible, since the new height     *
2650  REMark * will be subtracted later at M_PULLD.         *
2660  REMark * The current position's at $24 of the working *
2670  REMark * definition (wwd), and the "origin" at the    *
2680  REMark * long word at byte 4 of the window definition *
2690  REMark * whose address is given in both wd(1) and     *
2700  REMark * PEEK_L(wwd1+4).                              *
2710  REMark ************************************************
2720  optr=PEEK_L(wwd1+$24)+PEEK_L(wd(1)+4)+PEEK_W(wwd1+$22)
2730                 REMark *********************************
2740  mv=BCHSZ(wwd1):REMark * mv is the change in size      *
2750                 REMark *********************************
2760  xmv%=-get_x%(mv):ymv%=get_y%(mv)
2770  REMark *************************************************
2780  REMark *   We now have to check that the new size is   *
2790  REMark *    within reasonable limits. It must be no    *
2800  REMark *     bigger than the maximum in the window     *
2810  REMark *  definition. It must be no smaller than the   *
2820  REMark *     minimum size for this window layout.      *
2830  REMark * This size is used in M_SETUP to arrive at the *
2840  REMark *                actual size.                   *
2850  REMark *  PEEK_L(wwd1+32) is the current window size.  *
2860  REMark * PEEK_L(wd(1)+$30) is the minimum size for the *
2870  REMark * first window layout. Since this is variable   *
2880  REMark *  we must eliminate the scaling flag ($4000)   *
2890  REMark *         for both x and y values.              *
2900  REMark * PEEK_L(PEEK_L(wwd1+4)) is the maximum size of *
2910  REMark *                  window.                      *
2920  REMark *   Finally newx% must be made even (by ev%).   *
2930  REMark *************************************************
2940 :
2950  newx%=ev%(min%(PEEK_W(PEEK_L(wwd1+4)),max%(PEEK_W(wd(1)+48)&&4095,PEEK_W(wwd1+32)-xmv%)))
2960  newy%=min%(PEEK_W(PEEK_L(wwd1+4)+2),max%(PEEK_W(wd(1)+50)&&4095,PEEK_W(wwd1+34)-ymv%))
2970 :
2980  REMark *****************************************************
2990  REMark *  BUNST unsets the working definition and throws   *
3000  REMark *                away the window.                   *
3010  REMark *      BRCHP returns its area to the heap.          *
3020  REMark *       CLOS closes the channel opened.             *
3030  REMark *  M_SETUP sets up the new working definition and   *
3040  REMark *        gives us its address (in wwd1).            *
3050  REMark *      M_PULLD pulls down a secondary window.       *
3060  REMark *****************************************************
3070 :
3080  BUNST wwd1:BRCHP wwd1:CLOS chid1
3090  wwd1=M_SETUP(#0,wd(1),newx%*2^16+newy%)
3100  chid1=M_PULLD(wwd1,optr-newy%)
3110 END DEFine
3120 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw  *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites, performing sleep and.     *
17105 REMark *    producing an app menu.                            *
17110 REMark *                                                      *
17120 REMark * Once Ex7_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX7_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sprite Menu Sleep"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex7_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
