1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX0 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX0_TASK':TURBO_taskn 'EX0 v1.06':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX0_bas v1.06
1090 REMark 25 OCT 08
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250 REMark                            **************************************
1260 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1270 REMark                            **************************************
1280 :
1290 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1300 :
1310 REMark ************************************************************
1320 REMark * We must set a primary window here if this is COMPILED.   *
1330 REMark *    (PRPOS can be thought of as PRimary POSitioned).      *
1340 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1350 REMark *    the window here must instead be "pulled down" as a    *
1360 REMark *                    secondary window.                     *
1370 REMark ************************************************************
1380 :
1390 REMark *******************************************************
1400 REMark * This is the repeat loop for reading the pointer and *
1410 REMark *          taking appropriate action                  *
1420 REMark *******************************************************
1430 REPeat lp
1440  k=WRPTR(wwd)
1450  r=255&&Get_x%(k)
1460  REMark ***************************************
1470  REMark *   r is the code extracted from k    *
1480  REMark *   255 -> a loose item               *
1490  REMark *   254 -> an event                   *
1500  REMark * otherwise the number of app. window *
1510  REMark *                                     *
1520  REMark *  get_y%(k) is the bottom word of k  *
1530  REMark *   and is the item or event number   *
1540  REMark ***************************************
1550  SELect ON r
1560   =255:REMark loose items
1570     IF Do_Loose%(Get_y%(k)):EXIT lp
1580   =254:REMark event
1590     IF Do_Event%(Get_y%(k)):EXIT lp
1600   =REMAINDER :REMark application window r
1610     IF Do_App%(r,Get_y%(k)):EXIT lp
1620  END SELect
1630 END REPeat lp
1640 STOP
1650 :
1660 DEFine PROCedure Finish
1670  REMark *************************************************
1680  REMark * BUNST unsets the working definition           *
1690  REMark * BRCHP returns its area to the heap            *
1700  REMark * CLOS closes the channel opened for the window *
1710  REMark *************************************************
1720  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
1730 :
1740         REMark ***************************************************
1750  BRECHP:REMark * Returns the space used by the window definition *
1760         REMark ***************************************************
1770  STOP
1780 END DEFine
1790 :
1800 DEFine FuNction Do_Loose%(num%)
1810  REMark routine to do loose items
1820  LOCal k,ans%
1830  k=num%:ans%=0
1840  REMark ********************************************
1850  REMark * There are 4 loose items, numbered 0 to 3 *
1860  REMark * 0 = the move icon                        *
1870  REMark * 1 = the size icon                        *
1880  REMark * 2 = the sleep icon                       *
1890  REMark * 3 = "ESC"                                *
1900  REMark ********************************************
1910  SELect ON k
1920   =3:Finish:ans%=1
1930   =1:Do_Size
1940   =0:Mve
1950   =2:Do_Sleep wwd,chid,wch%
1960  END SELect
1970                             REMark **********************************
1980  IF NOT k=3:D_LDRW num%,wwd:REMark * Resets the item to "available" *
1990                             REMark **********************************
2000  RETurn ans%
2010 END DEFine
2020 :
2030 DEFine FuNction Do_Event%(num%)
2040  REMark ***********************************
2050  REMark *   The select key for the four   *
2060  REMark * loose items, quit, move, resize *
2070  REMark *  and sleep is the same as for   *
2080  REMark *   the event, hence there is     *
2090  REMark * nothing for this function to do.*
2100  REMark *   Any other event keys are      *
2110  REMark *            ignored.             *
2120  REMark ***********************************
2190  RETurn 0
2195 :
2200 END DEFine
2210 :
2220 DEFine FuNction Do_App%(wind%,num%)
2230  RETurn 0:REMark "go on"
2240 END DEFine
2250 :
2260 DEFine PROCedure Do_Size
2270  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2280  REMark ************************************************
2290  REMark * optr is the value to be used for PRPOS/PULLD *
2300  REMark *  It is the current window position plus its  *
2310  REMark *            "origin" plus its size.           *
2320  REMark *   The first comes from $24 of the working    *
2330  REMark *  definition (wwd) the second and third from  *
2340  REMark * the long words at 4 and $20 respectively of  *
2350  REMark * the window definition whose address is given *
2360  REMark *      at both wd(0) and PEEK_L(wwd+4).        *
2370  REMark *                                              *
2380  REMark * Since the move icon is near the top left of  *
2390  REMark *   the window, we want to leave the bottom    *
2400  REMark * right corner as near its original position   *
2410  REMark *  as possible. We thus want to subtract the   *
2420  REMark * increase in size from the current "origin"   *
2430  REMark * position of the cursor. The increase is the  *
2440  REMark * current size less the new size. The value of *
2450  REMark * optr is adjusted later by subtracting the    *
2460  REMark *                 new size.                    *
2470  REMark ************************************************
2480  optr=PEEK_L(wwd+$24)+PEEK_L(wd(0)+4)+PEEK_L(wwd+$20)
2490                REMark *************************************
2500  mv=BCHSZ(wwd):REMark * mv is the reduction in size (x/y) *
2510                REMark *************************************
2520  xmv%=Get_x%(mv):ymv%=Get_y%(mv)
2530  REMark *************************************************
2540  REMark *   We now have to check that the new size is   *
2550  REMark *    within reasonable limits. It must be no    *
2560  REMark *     bigger than the maximum in the window     *
2570  REMark *  definition. It must be no smaller than the   *
2580  REMark *     minimum size for this window layout.      *
2590  REMark * This size is used in M_SETUP to arrive at the *
2600  REMark *                 actual size.                  *
2610  REMark *  PEEK_L(wwd+32) is the current window size.   *
2620  REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2630  REMark *  first window layout. Since this is variable  *
2640  REMark *  we must eliminate the scaling flag ($4000)   *
2650  REMark *          for both x and y values.             *
2660  REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2670  REMark *                   window.                     *
2680  REMark *   Finally newx% must be made even (by ev%).   *
2690  REMark *************************************************
2700 :
2710  newx%=Ev%(Min%(PEEK_W(PEEK_L(wwd+4)),Max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%)))
2720  newy%=Min%(PEEK_W(PEEK_L(wwd+4)+2),Max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%))
2730 :
2740  REMark *****************************************************
2750  REMark *  BUNST unsets the working definition and throws   *
2760  REMark *       away the window if NOT COMPILED.            *
2770  REMark *     BRCHP returns its area to the heap.           *
2780  REMark *  CLOS closes the channel opened if not COMPILED.  *
2790  REMark *  M_SETUP sets up the new working definition and   *
2800  REMark *       gives us its address (in wwd).              *
2810  REMark *  M_PRPOS throws away the old window and sets up   *
2820  REMark * a new one. M_PULLD pulls down a secondary window. *
2830  REMark *****************************************************
2840  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
2850  mv=newx%*2^16+newy%
2860  wwd=M_SETUP(#wch%,wd(0),mv)
2870 REMark *********************************************
2880 REMark * We use optr - mv to keep the bottom right *
2890 REMark *            corner stationary.             *
2900 REMark * NOTE: optr - mv is made to be at least    *
2910 REMark *              "4*2^16 + 2"                 *
2920 REMark *********************************************
2930  IF COMPILED:chid=M_PRPOS(wwd,Adj(optr-mv)):ELSE :chid=M_PULLD(wwd,Adj(optr-mv))
2940 END DEFine
2950 :
2960 DEFine PROCedure Mve
2970  BCHWIN wwd
2980 END DEFine
2990 :
3000 DEFine FuNction Adj(mm)
3010  REMark mm is made to be at least "4*2^16 + 2"
3020  LOCal k%,l%
3030  k%=Get_x%(mm):l%=Get_y%(mm)
3040  IF k%>0
3050   IF l%>0:RETurn mm:ELSE l%=2
3060  ELSE
3070   k%=4:IF l%<0:l%=2
3080  END IF
3090  RETurn k%*2^16+l%
3100 END DEFine
3110 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We do not need the window definition    *
17030 REMark * to be at lines 19600 since Set_Win1 was used.        *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17090 REMark * 2. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites and setting an app menu.   *
17110 REMark *                                                      *
17120 REMark * Once Ex0_bas is loaded, pressing Mr, St, Charge      *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_Ex0_wda"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure St
18100  Remov "MenuSprite"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex0_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
