1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX1 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX1_TASK':TURBO_taskn 'EX1 v2.7':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX1_bas v2.7
1090 REMark 27 APR 08
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250 REMark                **************************************
1260 OPEN#4,con:    REMark * ex1 - for use in writing etc       *
1270 DIM str$(0,32):REMark * ex1 - string to contain directory  *
1280 REMark                **************************************
1290 :
1300 REMark                            **************************************
1310 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1320 push:          REMark             *      - sets a null menu  -         *
1330 REMark                            **************************************
1340 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1350 REMark ************************************************************
1360 REMark * We must set a primary window here if this is COMPILED .  *
1370 REMark * (PRPOS can be thought of as PRimary POSitioned)          *
1380 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1390 REMark * the window here must instead be "pulled down".           *
1400 REMark ************************************************************
1410 REMark                             *********************************
1420 SET_CHANNEL#4,SWIN(2,0,wwd):REMark *  sets #4                      *
1430 D_LDRW 16*65536+3,wwd:REMark       *  makes COPY unavailable       *
1440 prap:          REMark              *  prints in application window *
1450 REMark                             *********************************
1460 :
1470 REMark *******************************************************
1480 REMark * This is the repeat loop for reading the pointer and *
1490 REMark * taking apropriate action                            *
1500 REMark *******************************************************
1510 :
1520 REPeat lp
1530  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1540  r=255&&get_x%(k)
1550  SELect ON r
1560   =255:REMark loose items
1570     IF do_loose%(get_y%(k)):EXIT lp
1580   =254:REMark event
1590     IF do_event%(get_y%(k)):EXIT lp
1600   =REMAINDER :REMark application window k
1610     do_app r,get_y%(k)
1620  END SELect
1630 END REPeat lp
1640 STOP
1650 :
1660 DEFine PROCedure finish
1670  CLS#4:PRINT#4,"ENDED":SUSPEND_TASK 75:BUNST wwd:CLOS chid:REMark *  the window is removed *
1680  CLOSE#4:
1690  BRECHP:REMark *  all ALCHPd space returned to the heap *
1700 END DEFine
1710 :
1720 DEFine FuNction do_loose%(num)
1730  REMark *********************************************
1740  REMark * routine to do loose items                 *
1750  REMark * this returns 1 for "finished" else 0      *
1760  REMark *  the four loose items are 0 = move sprite *
1770  REMark *                           1 = ESC         *
1780  REMark *                           2 = DISPLAY     *
1790  REMark *                           3 = COPY        *
1800 REMark **********************************************
1810  LOCal ov%,nym
1820  ov%=0:nym=num:REMark Don't use parameter for SELect
1830  SELect ON nym
1840   =1:finish:ov%=1
1850   =0:mve1
1860  REMark ***************************************************
1870  REMark *  set_st puts the directory of FLP1 to str$      *
1880  REMark *  D_LDRW 3 & 2 set DISPLAY and COPY to available *
1890  REMark *  BWRSET redraws the window with the directory   *
1900  REMark ***************************************************
1910 :
1920   =2:set_st:D_LDRW 3,wwd:D_LDRW 2,wwd:BWRSET wwd
1930 :
1940  REMark ***************************************************
1950  REMark *  do_cop copies selected files                   *
1960  REMark *  push sets a null menu                          *
1970  REMark *  BWRSET redraws window with no scroll bar       *
1980  REMark *  prap redraws the instructions                  *
1990  REMark *  DEALLOCATE adr returns space used for the menu *
2000  REMark ***************************************************
2010 :
2020   =3:do_cop:push:BWRSET wwd:prap:DEALLOCATE adr
2030   =REMAINDER :ov%=1
2040  END SELect
2050  RETurn ov%
2060 END DEFine
2070 :
2080 DEFine FuNction do_event%(num%)
2090  REMark carry out event
2100  REMark only move and escape now
2110  LOCal ov%
2120  ov%=0
2130  IF 2&&num%:finish:ov%=1
2140  IF 8&&num%:mve1
2150  RETurn ov%
2160 END DEFine
2170 :
2180 DEFine PROCedure do_app(wind%,num%)
2190  REMark *********************************
2200  REMark * to do the menu item no num%   *
2210  REMark * in window number wind%        *
2220  REMark * no action need be taken here  *
2230  REMark *********************************
2240 :
2250 END DEFine
2260 :
2270 DEFine PROCedure mve1
2280  REMark to move window
2290  BCHWIN wwd
2300  D_LDRW 0,wwd
2310  SET_CHANNEL#4,SWIN(2,0,wwd)
2320 END DEFine
2330 :
2340 DEFine PROCedure prap
2350  REMark ******************************************
2360  REMark * this overwrites the application window *
2370  REMark * which now has a null menu              *
2380  REMark ******************************************
2390 :
2400  USE 4:CLS:PAPER BLACK%:OVER 0:INK WHITE%
2410  AT 2,2:PRINT "DISPLAY:":AT 5,2:PRINT "COPY:"
2420  INK GREEN%
2430  AT 3,3:PRINT "Shows files from flp1_"
2440  AT 6,3:PRINT "Copies selected files to ram1_"
2450  USE
2460 END DEFine
2470 :
2480 DEFine PROCedure set_st
2490  REMark * ex1 - to put flp1_ directory to application via str$ *
2500  LOCal x,k%,ch%,a$(52),lp,lp1,z,m%,top,pos
2510  ch%=N_CHAN%
2520  lp=DEVICE_STATUS(2,"ram1_dd"):lp=(lp=-8)+(lp<0)*2+(lp>=0)*4
2530  SELect ON lp
2540   =3:DELETE "ram1_dd"
2550   =4:REMark OK
2560   =REMAINDER : finish:STOP
2570  END SELect
2580  OPEN_NEW#ch%,"ram1_dd":REMark The quotation marks are needed for Turbo
2582  lp=DEVICE_STATUS(2,"flp1_anything"):lp=(lp=-8)+(lp<=0)*2+(lp>=0)*4
2583  SELect ON lp
2585   =3,4:REMark OK
2587   =REMAINDER :finish:CLOSE#ch%:STOP
2588  END SELect
2600  DIR#ch%,"flp1_" :REMark The quotation marks are needed to stop Turbo taking flp1_ as 0
2610  SET_POSITION#ch%,0:k%=0:USE ch%:m%=1
2620  INPUT a$:INPUT a$:REMark Step past Name and Status
2630  pos=POSITION(#ch%)
2640  REPeat lp
2650   IF EOF(#ch%):EXIT lp
2660   INPUT a$:IF "->" INSTR a$:NEXT lp
2670   k%=k%+1:m%=max%(m%,LEN(a$))
2680  END REPeat lp
2690  m%=ev%(m%):REMark round up to even
2700  REMark k%=number of files:m%=max length of name
2710  DIM str$(k%,m%)
2720  SET_POSITION#ch%,pos:x=1
2730  REPeat lp1
2740   IF EOF(#ch%):EXIT lp1
2750   INPUT a$:IF "->" INSTR a$:NEXT lp1
2760   str$(x)=a$:x=x+1
2770  END REPeat lp1
2780  USE:CLOSE#ch%
2790 :
2800  REMark **************************************
2810  REMark * adr -> the space used for the menu *
2820  REMark **************************************
2830 :
2840  adr=set_ap(str$,0,wwd)
2850 END DEFine
2860 :
2870 DEFine PROCedure do_cop
2880  REMark                     **********************************
2890  REMark                     * To copy marked files to ram1_  *
2900  LOCal x,ad,ae,k%
2910  ad=addr_appw(0,wwd):REMark *  address of status area        *
2920  ae=AD_SUB(0,1,wwd): REMark *  address of app. window        *
2930  k%=PEEK_W(ae+146):  REMark *  no of rows = items            *
2940  FOR x=1 TO k%
2950                      REMark *  ad+x-1 is 128 for 'selected'  *
2960  REMark                     **********************************
2970   IF PEEK(ad+x-1):Cop_Fl str$(x)
2980  END FOR x
2990  D_LDRW 16*65536+3,wwd
3000 END DEFine
3010 :
3020 DEFine PROCedure push
3030  REMark *  to set a null menu *
3040  LOCal ae
3050 :
3060  REMark                     **************************
3070  ae=AD_SUB(0,1,wwd): REMark * address of app. window *
3080  POKE_L ae+70,0:REMark      * no y-control block     *
3090  POKE_L ae+28,0:REMark      * no control routine     *
3100  POKE_L ae+32,0:REMark      * no control sections    *
3110  POKE_L ae+20,0:REMark      * no draw routine        *
3120  POKE_L ae+152,0:POKE_L ae+156,0:POKE_L ae+168,0
3130  POKE_L ae+144,0:REMark     * no rows OR cols        *
3140  POKE_L ae+100,0:REMark     * no status block        *
3150  POKE_W ae+150,6:REMark     * room for arrows        *
3160  REMark                     *                        *
3170  REMark                     * Scroll bar & arrows    *
3180  REMark                     * are set to green,      *
3190  REMark                     * background to white    *
3200  REMark                     **************************
3210 :
3220  POKE_W ae+94,GREEN%:POKE_W ae+94+2,WHITE%:POKE_W ae+94+4,GREEN%
3230 END DEFine
3240 :
3250 DEFine PROCedure Cop_Fl(a$)
3260  LOCal st
3270  st=DEVICE_STATUS(2,"ram1_"&a$)
3280  IF st<0:RETurn
3290  IF st=-8:DELETE "ram1_"&a$
3300  COPY "flp1_"&a$,"ram1_"&a$
3310 END DEFine
3320 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw  *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites and performing sleep.      *
17110 REMark *                                                      *
17120 REMark * Once Ex1_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX1_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sleep Sprite"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex1_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
