1000 :
1010 REMark *************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX3 *
1030 REMark *************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX3_TASK':TURBO_taskn 'EX3 v3.6':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX3_bas v3.6
1090 REMark 18 OCT 08
1100 :
1110 IF MODE%=8:MODE 4
1120 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1130 :
1140 REMark **************************************
1150 REMark * wch% is used by M_SETUP, see later *
1160 REMark **************************************
1170 :
1180 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1190 :
1200 REMark **********************************************************************
1210 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1220 REMark * and sets wd(r), the address(es) of window definition(s)            *
1230 REMark **********************************************************************
1240 :
1250                         REMark **************************
1260 OPEN#4,con:wink%=GREEN%:REMark *  for drawing to screen *
1270                         REMark **************************
1280 :
1290 REMark                            **************************************
1300 wwd=M_SETUP(#wch%,wd(0),0):REMark * To produce the working definition  *
1310 REMark                            **************************************
1320 :
1330 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1340 :
1350 REMark ************************************************************
1360 REMark * We must set a primary window here if this is COMPILED.   *
1370 REMark * (PRPOS can be thought of as PRimary POSitioned).         *
1380 REMark * If this is not COMPILED, BOUTL has set #0 as primary, so *
1390 REMark * the window here must instead be "pulled down" as a       *
1400 REMark * secondary window.                                        *
1410 REMark ************************************************************
1420 :
1430                             REMark *******************
1440 SET_CHANNEL#4,SWIN(0,1,wwd):REMark * 2nd inf window  *
1450                             REMark *******************
1460 :
1470                 REMark **************************
1480 set_lim:        REMark * Set x/y wee/big for #4 *
1490 wron%=1:on_off: REMark * To set on/off to OFF   *
1500                 REMark **************************
1510 :
1520 REMark *******************************************************
1530 REMark * This is the repeat loop for reading the pointer and *
1540 REMark * taking apropriate action                            *
1550 REMark *******************************************************
1560 REPeat lp
1570  k=WRPTR(wwd)
1580  r=255&&get_x%(k)
1590  REMark ***************************************
1600  REMark * r is the code extracted from k      *
1610  REMark * 255 -> a loose item                 *
1620  REMark * 254 -> an event                     *
1630  REMark * otherwise the number of app. window *
1640  REMark *                                     *
1650  REMark * get_y%(k) is the bottom word of k   *
1660  REMark * and is the item or event number     *
1670  REMark ***************************************
1680  SELect ON r
1690   =255:REMark loose items
1700     IF do_loose%(get_y%(k)):EXIT lp
1710   =254:REMark event
1720     IF do_event%(get_y%(k)):EXIT lp
1730   =REMAINDER :REMark application window r
1740     IF do_app%(r,get_y%(k)):EXIT lp
1750  END SELect
1760 END REPeat lp
1770 STOP
1780 :
1790 DEFine PROCedure finish
1800  REMark *************************************************
1810  REMark * BUNST unsets the working definition           *
1820  REMark * BRCHP returns its area to the heap            *
1830  REMark * CLOS closes the channel opened for the window *
1840  REMark *************************************************
1850  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
1860  CLOSE#4
1870         REMark ***************************************************
1880  BRECHP:REMark * Returns the space used by the window definition *
1890         REMark ***************************************************
1900  STOP
1910 END DEFine
1920 :
1930 DEFine FuNction do_loose%(num%)
1940  REMark routine to do loose items
1950  LOCal k,ans%
1960  k=num%:ans%=0
1970  REMark ********************************************
1980  REMark * There are 5 loose items, numbered 0 to 4 *
1990  REMark * 0 = the move icon                        *
2000  REMark * 1 = the size icon                        *
2010  REMark * 2 = "ESC"                                *
2020  REMark * 3 = "Clear"                              *
2030  REMark * 4 = "OFF" or "ON"                        *
2040  REMark ********************************************
2050  SELect ON k
2060   =2:finish:ans%=1
2070   =1:do_size
2080   =0:mve
2090   =3:CLS#4
2100   =4:on_off:dloop:on_off
2110  END SELect
2120                             REMark **********************************
2130  IF NOT k=2:D_LDRW num%,wwd:REMark * Resets the item to "available" *
2140                             REMark **********************************
2150  RETurn ans%
2160 END DEFine
2170 :
2180 DEFine FuNction do_event%(num%)
2190  REMark ***********************************
2200  REMark * Each of these three events      *
2210  REMark * can also be accessed via the    *
2220  REMark * appropriate loose item          *
2230  REMark * 2 = quit, 8 = move, 16 = resize *
2240  REMark * When the action is done this    *
2250  REMark * returns 1 for stop, 0 for go on *
2260  REMark ***********************************
2270  LOCal as%
2280  as%=0
2290  IF 2&&num%:finish:as%=1
2300  IF 8&&num%:mve
2310  IF 16&&num%:do_size
2320  RETurn as%
2330 END DEFine
2340 :
2350 DEFine FuNction do_app%(wind%,num%)
2360  RETurn 0:REMark "go on"
2370 END DEFine
2380 :
2390 DEFine PROCedure do_size
2400  LOCal mv,xmv%,ymv%,newx%,newy%,optr
2410  REMark ************************************************
2420  REMark * optr is the value to be used for PRPOS/PULLD *
2430  REMark *  It is the current window position plus its  *
2440  REMark *            "origin" plus its size.           *
2450  REMark *   The first comes from $24 of the working    *
2460  REMark *  definition (wwd) the second and third from  *
2470  REMark * the long words at 4 and $20 respectively of  *
2480  REMark * the window definition whose address is given *
2490  REMark *      at both wd(0) and PEEK_L(wwd+4).        *
2500  REMark                                                *
2510  REMark * Since the move icon is near the top left of  *
2520  REMark *   the window, we want to leave the bottom    *
2530  REMark * right corner as near its original position   *
2540  REMark *  as possible. We thus want to subtract the   *
2550  REMark * increase in size from the current "origin"   *
2560  REMark * position of the cursor. The increase is the  *
2570  REMark * current size less the new size. The value of *
2580  REMark * optr is adjusted later by subtracting the    *
2590  REMark *                 new size.                    *
2600  REMark ************************************************
2610  optr=PEEK_L(wwd+$24)+PEEK_L(wd(0)+4)+PEEK_L(wwd+$20)
2620                REMark *************************************
2630  mv=BCHSZ(wwd):REMark * mv is the reduction in size (x/y) *
2640                REMark *************************************
2650  xmv%=get_x%(mv):ymv%=get_y%(mv)
2660  REMark *************************************************
2670  REMark * We now have to check that the new size is     *
2680  REMark * within reasonable limits. It must be no       *
2690  REMark * bigger than the maximum in the window         *
2700  REMark * definition. It must be no smaller than the    *
2710  REMark * minimum size for this window layout.          *
2720  REMark * This size is used in M_SETUP to arrive at the *
2730  REMark * actual size.                                  *
2740  REMark * PEEK_L(wwd+32) is the current window size.    *
2750  REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2760  REMark * first window layout. Since this is variable   *
2770  REMark * we must eliminate the scaling flag ($4000)    *
2780  REMark * for both x and y values.                      *
2790  REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2800  REMark * window.                                       *
2810  REMark * Finally newx% must be made even (by ev%).     *
2820  REMark *************************************************
2830 :
2840  newx%=ev%(min%(PEEK_W(PEEK_L(wwd+4)),max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%)))
2850  newy%=min%(PEEK_W(PEEK_L(wwd+4)+2),max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%))
2860 :
2870  REMark *****************************************************
2880  REMark * BUNST unsets the working definition and throws    *
2890  REMark * away the window if NOT COMPILED.                  *
2900  REMark * BRCHP returns its area to the heap.               *
2910  REMark * CLOS closes the channel opened if not COMPILED.   *
2920  REMark * M_SETUP sets up the new working definition and    *
2930  REMark * gives us its address (in wwd).                    *
2940  REMark * M_PRPOS throws away the old window and sets up    *
2950  REMark * a new one. M_PULLD pulls down a secondary window. *
2960  REMark * All that remains is to reset #4, find the limits  *
2970  REMark * to this window via set_lim and to set on/off to   *
2980  REMark * OFF just as for a window move.                    *
2990  REMark *****************************************************
3000  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
3010  mv=newx%*2^16+newy%
3020  wwd=M_SETUP(#wch%,wd(0),mv)
3030 REMark *********************************************
3040 REMark * We use optr - mv to keep the bottom right *
3050 REMark *            corner stationary.             *
3060 REMark *********************************************
3070  IF COMPILED:chid=M_PRPOS(wwd,Adj(optr-mv)):ELSE :chid=M_PULLD(wwd,Adj(optr-mv))
3080  SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off
3090  set_lim
3100 END DEFine
3110 :
3120 DEFine PROCedure mve
3130  REMark ***************************************
3140  REMark * On a move we must:                  *
3150  REMark *     1. reset #4                     *
3160  REMark *     2. set on/off -> OFF            *
3170  REMark *     3. reset the limits for drawing *
3180  REMark ***************************************
3190  BCHWIN wwd:SET_CHANNEL#4,SWIN(0,1,wwd):wron%=1:on_off:set_lim
3200 END DEFine
3210 :
3220 DEFine PROCedure on_off
3230  REMark *******************************************
3240  REMark * This sets loose item 4 on<->off         *
3250  REMark *       and sets wron%=1<->0.             *
3260  REMark * wron%^^1 switches wron% between 0 and 1 *
3270  REMark * STLOB sets ON or OFF to loose item 4.   *
3280  REMark * G_Txt returns the address of the text   *
3290  REMark * item number 2 or 3 ie "ON " or "OFF".   *
3300  REMark *                                         *
3310  REMark *  For ON loose items are "unavailable".  *
3320  REMark *   For OFF they are all "available".     *
3330  REMark *******************************************
3340  LOCal x
3350  STLOB 4,G_Txt(wron%+2),wwd:wron%=wron%^^1
3360  FOR x=0 TO 4:D_LDRW x+65536*16*wron%,wwd
3370 END DEFine
3380 :
3390 DEFine PROCedure blk(w)
3400  LOCal px%,py%
3410  REMark **************************************
3420  REMark *  w is the pointer position.        *
3430  REMark *  A two by one block is drawn there *
3440  REMark *  provided it fits in #4.           *
3450  REMark **************************************
3460  px%=get_x%(w):py%=get_y%(w)
3470  IF xwee%<=px% AND px%<xbig%-1 AND ywee%<=py% AND py%<ybig%
3480   BLOCK#4,2,1,px%-xwee%,py%-ywee%,wink%
3490  END IF
3500 END DEFine
3510 :
3520 DEFine PROCedure dloop
3530  LOCal pptr,kk,lp,pold
3540  REMark **********************************
3550  REMark * The pointer is read directly - *
3560  REMark * returning on a key stroke or a *
3570  REMark *       key held down.           *
3580  REMark **********************************
3590 :
3600  REMark *****************************************************
3610  REMark * First we set pptr to the current pointer position *
3620  REMark *  Then via BRPTR we discover what key has been     *
3630  REMark *          pressed and act accordingly.             *
3640  pold=WH_PTR(wwd):REMark *  Current pointer position        *
3650  REMark *****************************************************
3660  REPeat lp
3670   pptr=BRPTR(3,pold,wwd): REMark *       new position       *
3680   kk=PEEK(PEEK_L(wwd)+18):REMark *       key stroke         *
3690   SELect ON kk
3700    =1:Do_Loop1
3710    =CODE('C'),CODE('c'):CLS#4
3720    =2:EXIT lp:       REMark *       Return to the main menu *
3730    =CODE('g'),CODE("G"):wink%=GREEN%:REMark *       These   *
3740    =CODE('r'),CODE("R"):wink%=RED%:  REMark *       set the *
3750    =CODE('w'),CODE("W"):wink%=WHITE%:REMark *       block   *
3760    =CODE('b'),CODE("B"):wink%=BLACK%:REMark *       colour  *
3770   END SELect
3780  END REPeat lp
3790 END DEFine
3800 :
3810 DEFine PROCedure set_lim
3820  LOCal ach
3830  REMark ****************************************************
3840  REMark *  ach         is #4's base                        *
3850  REMark *  xwee%/ywee% is the top left extreme for a block *
3860  REMark *  xbig%/ybig% is the bottom right extreme         *
3870  REMark ****************************************************
3880  ach=CH_BAS(CHANNEL_ID(#4))
3890  xwee%=PEEK_W(ach+24):ywee%=PEEK_W(ach+26)
3900  xbig%=PEEK_W(ach+28)+xwee%:ybig%=PEEK_W(ach+30)+ywee%
3910 END DEFine
3920 :
3930 DEFine PROCedure blk1(fst,lst)
3940  REMark *******************************************************
3950  REMark *     This draws a line between fst and lst.          *
3960  REMark *        If fst=lst we just plot a point.             *
3970  REMark * Otherwise we plot points counting through whichever *
3980  REMark *           of x and y changes most.                  *
3990  REMark *     Each point is a wee block drawn by blk.         *
4000  REMark *******************************************************
4010  LOCal xo%,xn%,yo%,yn%,z,sp
4020  IF fst=lst:blk fst:RETurn
4030  xo%=get_x%(fst):xn%=get_x%(lst):yo%=get_y%(fst):yn%=get_y%(lst)
4040  IF ABS((xn%-xo%))>ABS((yn%-yo%))
4050   sp=1-2*(xo%>xn%)
4060   FOR z=xo% TO xn% STEP sp:blk z*2^16+INT(((yn%-yo%)*(z-xo%))/(xn%-xo%))+yo%
4070  ELSE
4080   sp=1-2*(yo%>yn%)
4090   FOR z=yo% TO yn% STEP sp:blk (INT(((xn%-xo%)*(z-yo%))/(yn%-yo%))+xo%)*2^16+z
4100  END IF
4110 END DEFine
4120 :
4130 DEFine PROCedure Do_Loop1
4140  REMark ************************************************
4150  REMark *         Here we draw in #4 until             *
4160  REMark *     the left mouse button is raised.         *
4170  REMark *                                              *
4180  REMark *     First we find where the pointer is       *
4190  REMark *    by using BRPTR with a return vector       *
4200  REMark *    of 48 which always returns immediately.   *
4210  REMark *  We then use BRPTR in a loop returning only  *
4220  REMark *        on a move or button up.               *
4230  REMark *  If the pointer moves we use blk1 to draw.   *
4240  REMark *  If the pointer has not moved the program    *
4250  REMark *                returns.                      *
4260  REMark ************************************************
4270  LOCal old_p,new_p,lp
4280  old_p=BRPTR(48,0,wwd):blk1 old_p,old_p
4290  REPeat lp
4300   new_p=BRPTR(12,old_p,wwd)
4310   IF new_p=old_p:EXIT lp
4320   blk1 old_p,new_p
4330   old_p=new_p
4340  END REPeat lp
4350 END DEFine
4360 :
4370 DEFine FuNction Adj(mm)
4380  REMark mm is made to be at least "4*2^16 + 2"
4390  LOCal k%,l%
4400  k%=get_x%(mm):l%=get_y%(mm)
4410  IF k%>0
4420   IF l%>0:RETurn mm:ELSE l%=2
4430  ELSE
4440   k%=4:IF l%<0:l%=2
4450  END IF
4460  RETurn k%*2^16+l%
4470 END DEFine
4480 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw  *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites, performing sleep and.     *
17105 REMark *    producing an app menu.                            *
17110 REMark *                                                      *
17120 REMark * Once Ex3_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX3_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sleep Sprite Menu"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex3_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
