1000 :
1010 REMark **********************************************************************
1020 REMark *    The following three lines instruct Turbo how to compile Ex4     *
1030 REMark **********************************************************************
1040 :
1050 TURBO_objfil 'ram1_Ex4_TASK':TURBO_taskn 'Ex4 v1.04':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 TURBO_model '<':TURBO_struct 's'
1080 :
1090 REMark **********************************************************************
1100 REMark *         MANIFEST sets constants, not variables, for speed          *
1110 REMark **********************************************************************
1120 :
1130 MANIFEST: ws_citem=$30:ws_cibrw=$32:ws_cipap=$34:ws_cihit=$38
1140 MANIFEST: ws_ptpos=$20:Move_Win=$F5:ESC=27
1150 :
1160 REMark Ex4_bas v1.04
1170 REMark 18 OCT 08
1180 :
1190 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1200 :
1210 REMark **********************************************************************
1220 REMark *                  wch% is used by M_SETUP                           *
1230 REMark *           wch% is 100 if compiled and 0 otherwise                  *
1240 REMark **********************************************************************
1250 :
1260 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1270 :
1280 :                    REMark *************************************************
1290 OPEN#4,con:OVER#4,-1:REMark * Channel #4 is for Information Window 1        *
1300 :                    REMark *************************************************
1310 :
1320 REMark **********************************************************************
1330 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1340 REMark * and sets wd(r), the address(es) of window definition(s)            *
1350 REMark **********************************************************************
1360 :
1370 REMark                            *******************************************
1380 wwd=M_SETUP(#wch%,wd(0),0):REMark *    To produce the working definition    *
1390 REMark                            *******************************************
1400 :
1410 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1420 :
1430 REMark **********************************************************************
1440 REMark *       We must set a primary window here if this is COMPILED.       *
1450 REMark *          (PRPOS can be thought of as PRimary POSitioned).          *
1460 REMark *      If this is not COMPILED, BOUTL has set #0 as primary, so      *
1470 REMark *         the window here must instead be "pulled down" as a         *
1480 REMark *                       secondary window.                            *
1490 REMark **********************************************************************
1500 :
1510 :                                     REMark ********************************
1520 SET_CHANNEL#4,SWIN(0,1,wwd):OVER#4,-1:REMark * Set #4 to Inf Window 1       *
1530 spr_adr=PEEK_L(wwd+$30):              REMark * Keep address of hand sprite  *
1540 :                                     REMark ********************************
1550 :
1560 REMark         **************************************************************
1570 Set_Thg:REMark *                   Set up a movable Thing                   *
1580 REMark         **************************************************************
1590 :
1600 REMark **********************************************************************
1610 REMark *         This is the repeat loop for reading the pointer and        *
1620 REMark *          taking appropriate action using BRPTR not WRPTR.          *
1630 REMark *                                                                    *
1640 REMark * "pos" is the current position of the pointer.                      *
1650 REMark * "lad" is the address of the loose item list.                       *
1660 REMark * "stad" is the address of the status area.                          *
1670 REMark * "no_li%" is the number of loose items - if none STOP.              *
1680 REMark *                                                                    *
1690 REMark * The reason for using BRPTR is to make use of its detailed          *
1700 REMark * facilities to allow "dragging" of an object.                       *
1710 REMark * Here BRPTR uses either return code "48" which means return         *
1720 REMark * immediately so that the pointer can be set, return code "11"       *
1730 REMark * which returns on a change of pointer position or a key/mouse       *
1740 REMark * press, or "12" which returns on button up or pointer moved.        *
1750 REMark *                                                                    *
1760 REMark * The use of BRPTR in place of WRPTR requires more work to be done.  *
1770 REMark * WRPTR automatically causes borders to appear round loose items     *
1780 REMark * when the pointer is inside their hit area. It also automatically   *
1790 REMark * delivers to the programmer the number of loose item which is the   *
1800 REMark * subject of a "hit" or "do", as well as the type of "event". All    *
1810 REMark * this has to be done by program when BRPTR is used.                 *
1820 REMark *                                                                    *
1830 REMark * 1. Borders                                                         *
1840 REMark * Borders are set up when a window is drawn or redrawn by the        *
1850 REMark * procedure Set_First. This occurs at the beginning or after a move. *
1860 REMark *                                                                    *
1870 REMark * The variable cite% is set to -1 when the pointer is not in any     *
1880 REMark * loose item's hit area. It is set to 0, 1 etc. when the pointer is  *
1890 REMark * in the hit area of the first, second etc. loose item.              *
1900 REMark * cite% indicates which, if any, border is currently drawn.          *
1910 REMark *                                                                    *
1920 REMark * Each time the pointer moves, its new position has to be checked    *
1930 REMark * and appropriate action taken. If it moves out of a hit area, the   *
1940 REMark * current border must be undone by using M_DRBDN(wwd,0). If the      *
1950 REMark * pointer is in another hit area M_DRBDR wwd,1 is used to draw the   *
1960 REMark * new border.                                                        *
1970 REMark *                                                                    *
1980 REMark * The action of moving a window causes all borders to disappear.     *
1990 REMark * Any borders needed are redrawn by calling Set_First                *
2000 REMark *                                                                    *
2010 REMark * 2. Actions                                                         *
2020 REMark * When BRPTR detects a key/mouse press, the ASCII value of the       *
2030 REMark * character is set in the Status Area at byte $12. Note, however     *
2040 REMark * that SPACE and ENTER have the values associated with "hit" and     *
2050 REMark * "do", that is 1 and 2.                                             *
2060 REMark * Examination of byte $12 enables appropriate actions to be taken.   *
2070 REMark *                                                                    *
2080 REMark * 3. Status Area                                                     *
2090 REMark * Some items in the Status Area are set by BRPTR and can be used by  *
2100 REMark * a programmer. Other items must be set by the programmer if they    *
2110 REMark * are to be used by window management routines such as BCHWIN and    *
2120 REMark * M_DRBDR.                                                           *
2130 REMark * The items that are available to the programmer are the pointer     *
2140 REMark * position relative to the origin of a window. This window is the    *
2150 REMark * main window if the word at $C is -1. The pointer position is at $E.*
2160 REMark * If the pointer position is -1, it means that the pointer is        *
2170 REMark * outside the main window altogether.                                *
2180 REMark * The byte at $12 is the value of the key/mouse pressed.             *
2190 REMark *                                                                    *
2200 REMark * For BCHWIN, the procedure to move the window, to work it is        *
2210 REMark * necessary for the absolute pointer position to be set at $20.      *
2220 REMark * For M_DRBDR to work, it is necessary for $30 to $40 to be set.     *
2230 REMark *                                                                    *
2240 REMark * $30 word  current item                                             *
2250 REMark * $32 word  border width                                             *
2260 REMark * $34 word  paper colour behind item                                 *
2270 REMark * $38 long  hit area size                                            *
2280 REMark * $3C long  hit area origin (absolute)                               *
2290 REMark **********************************************************************
2300 :
2310 lad=PEEK_L(wwd+$6A):stad=PEEK_L(wwd)
2320 Set_InfW
2330 no_li%=PEEK_W(wwd+$68):IF no_li%=0:finish
2340 DIM li_set%(no_li%)
2350 Set_First
2360  REPeat lp
2370   pos1=BRPTR(11,pos,wwd)
2380 :
2390    IF pos1<>pos
2400 :
2410 REMark **********************************************************************
2420 REMark *  We have a change in pointer position here. The current position   *
2430 REMark *   "pos" is updated and the new location of the pointer checked.    *
2440 REMark **********************************************************************
2450 :
2460     pos=pos1
2470     Chk_In
2480    ELSE
2490 :
2500 REMark **********************************************************************
2510 REMark *   A key/mouse press has occurred so appropriate action is taken.   *
2520 REMark **********************************************************************
2530 :
2540     y=PEEK(stad+$12)
2550     SELect ON y
2560      =ESC:EXIT lp
2570      =Move_Win:mve1
2580     =1,2:IF Do_Action:EXIT lp
2590    END SELect
2600   END IF
2610  END REPeat lp
2620  finish
2630 :
2640 DEFine PROCedure Set_First:     REMark **************************************
2650  LOCal x:                       REMark * -  To set borders from scratch  -  *
2660  pos=BRPTR(48,0,wwd):cite%=-1:  REMark *   pos is the absolute position     *
2670  FOR x=1 TO no_li%:li_set%(x)=0:REMark *   Clear the border set marker      *
2680  Chk_In:                        REMark *   Set the border and ws_ptpos      *
2690 END DEFine :                    REMark **************************************
2700 :
2710 REMark **********************************************************************
2720 REMark * Given a hit or a do Do_Action decides what action to take, if any. *
2730 REMark * cite%=-1 when the pointer is not on any loose item and is the item *
2740 REMark * number otherwise (0, 1 etc). so 0 -> move, 1 -> Exit, -1 -> Action *
2750 REMark *           A HIT not on a loose item -> Chk_InThg                   *
2760 REMark **********************************************************************
2770 :
2780 DEFine FuNction Do_Action
2790  REMark returns 1 if end, else 0
2800  LOCal x,ans
2810  x=cite%:ans=0
2820  SELect ON x
2830   =0:mve1
2840   =1:ans=1
2850   =REMAINDER : IF y=1:Chk_InThg
2860  END SELect
2870  RETurn ans
2880 END DEFine
2890 :
2900 REMark **********************************************************************
2910 REMark * Chk_In finds whether the pointer is in a hit area or not. If so it *
2920 REMark * sets a border round the item.                                      *
2930 REMark * If the pointer is in the window its position is set in the status  *
2940 REMark * area for "move".                                                   *
2950 REMark **********************************************************************
2960 :
2970 DEFine PROCedure Chk_In:                  REMark ****************************
2980  px%=PEEK_W(stad+$E):py%=PEEK_W(stad+$10):REMark * px/py is (rel) position  *
2990  lad1=lad:fd=0:                           REMark * of the pointer or -1     *
3000 :                                         REMark ****************************
3010  IF px%>=0
3020 :                                         REMark ****************************
3030 :                                         REMark *   px%>=0 if in window    *
3040   POKE_L ws_ptpos+stad,pos:               REMark *  Set pos (abs) for move  *
3050 :                                         REMark * We now set fd = 1 if the *
3060 :                                         REMark * pointer is in a hit area *
3070 :                                         REMark * ite% is the item number  *
3080 :                                         REMark ****************************
3090   IF PEEK_W(stad+12)=-1
3100   FOR ite%=1 TO no_li%
3110    IF Is_In(PEEK_W(lad1+4),PEEK_W(lad1+6),PEEK_W(lad1),PEEK_W(lad1+2)):fd=1:EXIT ite%
3120    lad1=lad1+$16
3130   END FOR ite%
3140  END IF :END IF
3150  IF fd
3160 :                                         REMark ****************************
3170 :                                         REMark * We are inside a hit area *
3180 :                                         REMark * If it has no border . .
3190   IF cite%<>ite%-1
3200    B_Unset 0:                             REMark * . . take away the last   *
3210 :                                         REMark *      one if any          *
3220    B_Set ite%:                            REMark *   and set this border    *
3230 :                                         REMark ****************************
3240   END IF
3250  ELSE
3260 :                                         REMark ****************************
3270 :                                         REMark * We are not inside a hit  *
3280 :                                         REMark *      area, so            *
3290   B_Unset (px%<0):                        REMark * if we are in the window  *
3300 :                                         REMark *   unset any borders.     *
3310   cite%=-1:                               REMark *    Mark "no borders"     *
3320   POKE_W ws_citem+stad,-1:                REMark * and set "no item number" *
3330 :                                         REMark ****************************
3340  END IF
3350 END DEFine
3360 :
3370 REMark **********************************************************************
3380 REMark *   B_Set x sets a border round the xth loose item provided it is    *
3390 REMark *                 either "selected" or "available".                  *
3400 REMark *           cite% is set to the current item (0, 1 etc).             *
3410 REMark * To set the border we must indicate to M_DRBDR via the status area  *
3420 REMark *  which item is (ws_citem), how wide the border (ws_cibrw), what    *
3430 REMark *  colour (ws_cipap), the size of the hit area (ws_cihit) and its    *
3440 REMark *                        origin (ws_cihit + 4).                      *
3450 REMark *                                                                    *
3460 REMark * The values of these items come from the working definition at wwd  *
3470 REMark *                   and the loose item data at lad1.                 *
3480 REMark *                                                                    *
3490 REMark * After the border is drawn ws_cipap is reset to the main window's   *
3500 REMark *  paper colour. Also li_set%(x) is set to 1 to indicate that x's    *
3510 REMark *                         border is drawn.                           *
3520 REMark **********************************************************************
3530 :
3540 DEFine PROCedure B_Set(x)
3550    cite%=x-1
3560    IF PEEK(stad+x+$6F)<>$10
3570     POKE_W ws_citem+stad,x-1
3580     POKE_W ws_cibrw+stad,PEEK_W(wwd+$34)
3590     POKE_W ws_cipap+stad,PEEK_W(wwd+$36)
3600     POKE_L ws_cihit+stad,PEEK_L(lad1)
3610     POKE_L ws_cihit+4+stad,PEEK_L(lad1+4)+PEEK_L(wwd+$24)
3620     M_DRBDR wwd,1
3630     POKE_W ws_cipap+stad,PEEK_W(wwd+$2E)
3640     li_set%(x)=1
3650  END IF
3660 END DEFine
3670 :
3680 REMark **********************************************************************
3690 REMark *       B_Unset unsets the item indicated by li_set% as set          *
3700 REMark *  All we need do is to set the item number in the status area and   *
3710 REMark *  call M_DRBDN. We then set li_set% to zero to mark 'no borders'    *
3720 REMark *  We call the FUNCTION M_DRBDN because we can ignore the spurious   *
3730 REMark *  error that occurs when we undraw the borders if the pointer is    *
3740 REMark *                   not still in the window.                         *
3750 REMark **********************************************************************
3760 :
3770 DEFine PROCedure B_Unset(fx)
3780   LOCal ite%,erc
3790   FOR ite%=1 TO no_li%
3800    IF li_set%(ite%)=1
3810     POKE_W ws_citem+stad,ite%-1
3820     erc=M_DRBDN(wwd,0):IF fx:IF erc=-4:erc=0
3830     IF erc:Stip
3840     li_set%(ite%)=0
3850     EXIT ite%
3860    END IF
3870   END FOR ite%
3880 END DEFine
3890 :
3900 REMark **********************************************************************
3910 REMark * Is_In checks whether the pointer at px%/py% (relative) is inside   *
3920 REMark *  or outside the area size xz%/yz% and relative position xo%/yo%    *
3930 REMark **********************************************************************
3940 :
3950 DEFine FuNction Is_In(xo%,yo%,xz%,yz%)
3960  IF xo%>px%:RETurn 0
3970  IF yo%>py%:RETurn 0
3980  IF xo%+xz%<px%:RETurn 0
3990  IF yo%+yz%<py%:RETurn 0
4000  RETurn 1
4010 END DEFine
4020 :
4030 DEFine PROCedure finish
4040  PRINT#0,"ENDED":BUNST wwd:BRCHP wwd:CLOS chid
4050  CLOSE#4
4060  BRECHP:STOP
4070 END DEFine
4080 :
4090 DEFine PROCedure mve1
4100  D_LDRW 128*65536,wwd:            REMark ************************************
4110  BCHWIN wwd:                      REMark *          Move the window         *
4120  Set_First:                       REMark *     Set borders from scratch     *
4130  SET_CHANNEL#4,SWIN(0,1,wwd):     REMark *        Reset Channel #4          *
4140  OVER#4,-1:                       REMark *                                  *
4150  D_LDRW 0,wwd:                    REMark ************************************
4160 END DEFine
4170 :
4180 REMark **********************************************************************
4190 REMark *    The Thing is a rectangle size th_xz, th_yz at th_xp, th_yp      *
4200 REMark *            It is intially printed black by Prt_Thg                 *
4210 REMark **********************************************************************
4220 :
4230 DEFine PROCedure Set_Thg
4240  th_xz=24:th_yz=12:th_xp=10:th_yp=10
4250  Prt_Thg WHITE%
4260 END DEFine
4270 :
4280 REMark **********************************************************************
4290 REMark *           Prt_Thg prints the Thing block with colour o%            *
4300 REMark **********************************************************************
4310 :
4320 DEFine PROCedure Prt_Thg(o%)
4330  BLOCK#4,th_xz,1,th_xp,th_yp,o%
4340  BLOCK#4,th_xz,1,th_xp,th_yp+th_yz-1,o%
4350  BLOCK#4,1,th_yz-2,th_xp,th_yp+1,o%
4360  BLOCK#4,1,th_yz-2,th_xp+th_xz-1,th_yp+1,o%
4370 END DEFine
4380 :
4390 REMark **********************************************************************
4400 REMark *    Set_InfW finds the size and relative position of Information    *
4410 REMark *                   Window 1 for Chk_InThg                           *
4420 REMark **********************************************************************
4430 :
4440 DEFine PROCedure Set_InfW
4450  LOCal b_adr
4460  b_adr=PEEK_L(wwd+$64)+$14
4470  inf_xp=PEEK_W(b_adr+4):inf_yp=PEEK_W(b_adr+6)
4480  inf_xz=PEEK_W(b_adr):inf_yz=PEEK_W(b_adr+2)
4490 END DEFine
4500 :
4510 REMark **********************************************************************
4520 REMark *   Chk_InThg finds if the pointer is in the Thing by using Is_In.   *
4530 REMark * If it is inside, the colour of the Thing is made red (by Ptr_Thg)  *
4540 REMark * and the sprite is changed to number 1, by setting G_SBp(0,1) to    *
4550 REMark *     the working definition's sprite address which is wwd+$30.      *
4560 REMark *       Sprite number 1 is the invisible sprite nul_spr.             *
4570 REMark *   The maximum and minimum values of the pointer position are now   *
4580 REMark *  found. These are the current position adjusted by the distances   *
4590 REMark *       the Thing can move inside the Information Window.            *
4600 REMark *                                                                    *
4610 REMark *   BRPTR(12,pos,wwd) returns the pointer position when either the   *
4620 REMark *         pointer moves or the left mouse key is lifted.             *
4630 REMark *  If the position changes it is forced to be within the limits set  *
4640 REMark *  If it isn't it is positioned at the limits of x- or y- or both.   *
4650 REMark *    If the position has changed, the Thing is redrawn at its new    *
4660 REMark *                            place.                                  *
4670 REMark *  If the pointer has not moved, it means that the mouse button has  *
4680 REMark *   been raised. In that case the hand sprite is replaced and the    *
4690 REMark *                   Thing set to black again.                        *
4700 REMark **********************************************************************
4710 :
4720 DEFine PROCedure Chk_InThg
4730  LOCal lp,opos,chps,posx1,posy1
4740  px%=PEEK_W(stad+$E):py%=PEEK_W(stad+$10)
4750  IF Is_In(th_xp+inf_xp,th_yp+inf_yp,th_xz,th_yz)
4760   Prt_Thg RED%:POKE_L wwd+$30,G_Sbp(0,1)
4770   max_posx=get_x%(pos)+inf_xz-th_xp-th_xz
4780   min_posx=get_x%(pos)-th_xp
4790   max_posy=get_y%(pos)+inf_yz-th_yp-th_yz
4800   min_posy=get_y%(pos)-th_yp
4810   REPeat lp
4820    opos=pos
4830    chps=0:pos1=BRPTR(12,pos,wwd)
4840    IF pos1=pos:EXIT lp
4850    posx1=get_x%(pos1):posy1=get_y%(pos1)
4860    IF posx1>max_posx:posx1=max_posx:chps=1:ELSE :IF posx1<min_posx:posx1=min_posx:chps=1
4870    IF posy1>max_posy:posy1=max_posy:chps=1:ELSE :IF posy1<min_posy:posy1=min_posy:chps=1
4880    IF chps:pos=posx1*2^16+posy1:SET_PTR wwd,pos:ELSE pos=pos1
4890    IF opos<>pos
4900     Prt_Thg CYAN%
4910     chps=th_xp*2^16+th_yp+pos-opos
4920     th_xp=get_x%(chps):th_yp=get_y%(chps)
4930     Prt_Thg CYAN%
4940    END IF
4950   END REPeat lp
4960   Prt_Thg RED%:POKE_L wwd+$30,spr_adr
4970  END IF
4980 END DEFine
4990 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw  *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites, performing sleep and.     *
17105 REMark *    producing an app menu.                            *
17110 REMark *                                                      *
17120 REMark * Once Ex4_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX4_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sleep Sprite Menu"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex4_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
