1000 :
1010 REMark **********************************************************************
1020 REMark * The following two lines instruct Turbo how to compile EX5          *
1030 REMark **********************************************************************
1040 :
1050 TURBO_objfil 'ram1_EX5_TASK':TURBO_taskn 'EX5 v2.03':TURBO_objdat 100
1060 TURBO_repfil 'ram1_err':TURBO_struct 1:TURBO_windo 0:TURBO_buffersz 300
1070 :
1080 REMark EX5_bas v2.03
1090 REMark 18 OCT 08
1100                    REMark ***************************************************
1110 g_mxw:             REMark * This sets the maximum window size in _max_x%/y% *
1120                    REMark ***************************************************
1130 IF MODE%=8:MODE 4
1140 IF COMPILED:OPEN#0,con:INK#0,GREEN%:wch%=100:ELSE :BOUTL:wch%=0
1150 :
1160 REMark                                 **************************************
1170 REMark                                 * wch% is used by M_SETUP, see later *
1180 REMark                                 **************************************
1190 :
1200 IF NOT Set_Win:PRINT#0,"I can't open my windows!":Stip
1210 :
1220 REMark **********************************************************************
1230 REMark * Set_Win sets the entire window definition from DATA lines @ 19600  *
1240 REMark * and sets wd(r), the address(es) of window definition(s)            *
1250 REMark **********************************************************************
1260 :
1270                                       REMark ********************************
1280 OPEN#4,con:                           REMark * #4 is for use in writing     *
1290 nofl=0:flp=0:DIM flnme$(42),ofln$(42):REMark * flp = 0 until flnme$ is set  *
1300 DIM q_title$(42),q_dir$(42),q_ext$(6):REMark * Used in Set_Pars below       *
1310 qm_set=0:lines%=0:                    REMark * QMenu not yet set            *
1320 DIM q_dir$(42):                       REMark * DIM directory string         *
1330 col1%=0:col2%=0:                      REMark * Colours to default           *
1340                                       REMark ********************************
1350 :
1360 REMark                     **************************************************
1370 REMark                     * We set the minimum window here.                *
1380 REMark                     * mmx% and mmy% are the minimum values needed.   *
1390 REMark                     * As in the resize operation, theses values come *
1400 REMark                     * from the window definition.                    *
1410 REMark                     **************************************************
1420 :
1430 mmx%=PEEK_W(wd(0)+48)&&4095:mmy%=PEEK_W(wd(0)+50)&&4095
1440 wwd=M_SETUP(#wch%,wd(0),mmx%*2^16+mmy%)
1450 IF COMPILED:chid=M_PRPOS(wwd,-1):ELSE :chid=M_PULLD(wwd,-1)
1460 :
1470 REMark           ************************************************************
1480 REMark           * We must set a primary window here if this is COMPILED.   *
1490 REMark           * (PRPOS can be thought of as PRimary POSitioned)          *
1500 REMark           * If this is not COMPILED, BOUTL has set #0 as primary, so *
1510 REMark           * the window here must instead be "pulled down".           *
1520 REMark           ************************************************************
1530 REMark                                      *********************************
1540 SET_CHANNEL#4,SWIN(0,1,wwd):REMark          *  sets #4 to inf window 1      *
1550 REMark                                      *********************************
1560 :
1570 REMark                *******************************************************
1580 REMark                * This is the repeat loop for reading the pointer and *
1590 REMark                * taking apropriate action                            *
1600 REMark                *******************************************************
1610 :
1620 REPeat lp
1630  k=WRPTR(wwd):REMark k indicates whether loose item, event or application
1640  r=255&&get_x%(k)
1650  SELect ON r
1660   =255:REMark loose items
1670     IF do_loose%(get_y%(k)):EXIT lp
1680   =254:REMark event
1690     IF do_event%(get_y%(k)):EXIT lp
1700   =REMAINDER :REMark application window k
1710     do_app r,get_y%(k)
1720  END SELect
1730 END REPeat lp
1740 STOP
1750 :
1760 DEFine PROCedure finish
1770  CLS#4:PRINT#4,"ENDED":SUSPEND_TASK 75
1780                                             REMark **************************
1790  BUNST wwd:CLOS chid:                       REMark *  the window is removed *
1800                                             REMark **************************
1810  CLOSE#4:
1820                             REMark ******************************************
1830  BRECHP:                    REMark *  all space returned to the heap        *
1840                             REMark ******************************************
1850 END DEFine
1860 :
1870 DEFine FuNction do_loose%(num)
1880                         REMark  *********************************************
1890                         REMark  * routine to do loose items                 *
1900                         REMark  * this returns 1 for "finished" else 0      *
1910                         REMark  *  the five loose items are 0 = move sprite *
1920                         REMark  *                           1 = size sprite *
1930                         REMark  *                           2 = ESC         *
1940                         REMark  *                           3 = Zzz sprite  *
1950                         REMark  *                           4 = Pick        *
1960                         REMark  *********************************************
1970  LOCal ov%
1980  ov%=0
1990  SELect ON num
2000   =0:mve1
2010   =1:do_size
2020   =2:finish:RETurn 1
2030   =3:Do_Sleep wwd,chid,wch%: SET_CHANNEL#4,SWIN(0,1,wwd):prinf
2040   =4:IF nofl=0:ofln$=flnme$:ELSE :nofl=0
2050      IF QM_Here
2060       Set_Pars:flnme$=Fle_Sel$("Choose a file",flnme$,q_dir$,q_ext$,lines%,20,10,col1%,col2%)
2070      ELSE
2080       flnme$=Do_NoQM$
2090      END IF
2100                                  REMark  ************************************
2110    flp=1:prinf:                  REMark  * Prints the filename              *
2120                                  REMark  ************************************
2130  END SELect
2140                                  REMark  ************************************
2150  D_LDRW num,wwd:                 REMark  * Makes loose item 'available'     *
2160                                  REMark  ************************************
2170  RETurn ov%
2180 END DEFine
2190 :
2200 DEFine FuNction do_event%(num%)
2210  REMark                                 *************************************
2220  REMark                                 * The events Sleep - CTRL/F1        *
2230  REMark                                 *             Move - CTRL/F4        *
2240  REMark                                 *             Size - CTRL/F3        *
2250  REMark                                 *           Cancel - ESC            *
2260  REMark                                 * are all dealt with by loose items *
2270  REMark                                 * so this routine is not needed.    *
2280  REMark                                 *************************************
2290 END DEFine
2300 :
2310 DEFine PROCedure do_app(wind%,num%)
2320  REMark                                     *********************************
2330  REMark                                     * to do the menu item no num%   *
2340  REMark                                     * in window number wind%        *
2350  REMark                                     * no action need be taken here  *
2360  REMark                                     *********************************
2370 :
2380 END DEFine
2390 :
2400 DEFine PROCedure mve1
2410  REMark to move window
2420  BCHWIN wwd
2430  SET_CHANNEL#4,SWIN(0,1,wwd)
2440 END DEFine
2450 :
2460 DEFine PROCedure prinf
2470  LOCal a$(30)
2480  REMark                            ******************************************
2490  REMark                            * this prints to inf 1                   *
2500  REMark                            ******************************************
2510 :
2520  IF flp=0:a$="No file picked yet": ELSE :a$=Scrp$
2530  USE 4:PAPER BLACK%:CLS:INK WHITE%
2540  PRINT a$
2550  INK GREEN%
2560  IF nofl=0 OR nofl=2:AT 2,1:PRINT flnme$
2570  USE
2580 END DEFine
2590 :
2600 DEFine PROCedure do_size
2610  LOCal mv,xmv%,ymv%,newx%,newy%,optr,xz%,yz%
2620                       REMark ************************************************
2630                       REMark * The value to be used for PRPOS/PULLD is the  *
2640                       REMark * current window position plus its 'origin'    *
2650                       REMark * plus the old size minus the new.             *
2660                       REMark * The first comes from $24 of the working      *
2670                       REMark * definition (wwd), the second from the long   *
2680                       REMark * word at byte 4 of the window definition      *
2690                       REMark * whose address is given in both wd(0) and     *
2700                       REMark * PEEK_L(wwd+4), and the third from wwd+$20.   *
2710                       REMark * The fourth will be found later and           *
2720                       REMark * subtracted from the total so far - optr.     *
2730                       REMark ************************************************
2740  optr=PEEK_L(wwd+36)+PEEK_L(wd(0)+4)+PEEK_L(wwd+32)
2750                       REMark            *************************************
2760  mv=BCHSZ(wwd):       REMark            * mv is the reduction in size (x/y) *
2770                       REMark            *************************************
2780  xmv%=get_x%(mv):ymv%=get_y%(mv)
2790                      REMark *************************************************
2800                      REMark * We now have to check that the new size is     *
2810                      REMark * within reasonable limits. It must be no       *
2820                      REMark * bigger than the maximum in the window         *
2830                      REMark * definition. It must be no smaller than the    *
2840                      REMark * minimum size for this window layout.          *
2850                      REMark * This size is used in M_SETUP to arrive at the *
2860                      REMark * actual size.                                  *
2870                      REMark * PEEK_L(wwd+32) is the current window size.    *
2880                      REMark * PEEK_L(wd(0)+$30) is the minimum size for the *
2890                      REMark * first window layout. Since this is variable   *
2900                      REMark * we must eliminate the scaling flag ($4000)    *
2910                      REMark * for both x and y values.                      *
2920                      REMark * PEEK_L(PEEK_L(wwd+4)) is the maximum size of  *
2930                      REMark * window.                                       *
2940                      REMark * Then newx% must be made even (by ev%).        *
2950                      REMark * Finally we must see that the size will allow  *
2960                      REMark * space for shadow and border and still fit     *
2970                      REMark * into the current maximum screen size.         *
2980  g_mxw:              REMark * We also find the current maximum screen size  *
2990                      REMark *************************************************
3000  xz%=_max_x%-4*PEEK(wwd+41)-4*PEEK_W(wwd+42):yz%=_max_y%-3*PEEK(wwd+41)-2*PEEK_W(wwd+42)
3010  newx%=min%(xz%,ev%(min%(PEEK_W(PEEK_L(wwd+4)),max%(PEEK_W(wd(0)+48)&&4095,PEEK_W(wwd+32)-xmv%))))
3020  newy%=min%(yz%,min%(PEEK_W(PEEK_L(wwd+4)+2),max%(PEEK_W(wd(0)+50)&&4095,PEEK_W(wwd+34)-ymv%)))
3030  mv=newx%*2^16+newy%
3040 :
3050                  REMark *****************************************************
3060                  REMark * BUNST unsets the working definition and throws    *
3070                  REMark * away the window if NOT COMPILED.                  *
3080                  REMark * BRCHP returns its area to the heap.               *
3090                  REMark * CLOS closes the channel opened if not COMPILED.   *
3100                  REMark * M_SETUP sets up the new working definition and    *
3110                  REMark * gives us its address (in wwd).                    *
3120                  REMark * M_PRPOS throws away the old window and sets up    *
3130                  REMark * a new one. M_PULLD pulls down a secondary window. *
3140                  REMark * All that remains is to reset #4.                  *
3150                  REMark *****************************************************
3160 :
3170  BUNST wwd:BRCHP wwd:IF NOT COMPILED:CLOS chid
3180  wwd=M_SETUP(#wch%,wd(0),newx%*2^16+newy%)
3190  IF COMPILED:chid=M_PRPOS(wwd,optr-mv):ELSE :chid=M_PULLD(wwd,optr-mv)
3200  SET_CHANNEL#4,SWIN(0,1,wwd):prinf
3210 END DEFine
3220 :
3230 DEFine PROCedure Set_Pars
3240  REMark                                          ****************************
3250  REMark                                          * This illustrates the use *
3260  REMark                                          * of the Qmenu extras:     *
3270  REMark                                          *   READ_STRING$ and       *
3280  REMark                                          *   ITEM_SELECT            *
3290  REMark                                          ****************************
3300  LOCal cho
3310  Set_PosCol
3320  POKE_L vadr2,adrit_sel
3330  cho=TURBO_DUMMYF("To Set Directory and Extension","Press ESC -> none","Directory only","Extension only","Both",20,10,col1%)
3340  SELect ON cho
3350   =0:q_dir$="ram1_":q_ext$=""
3360   =1:ch_fl
3370   =2:ch_ex
3380   =3:ch_fl:ch_ex
3390  END SELect
3400 END DEFine
3410 :
3420 DEFine PROCedure ch_fl
3430  POKE_L vadr1,adrrd_str
3440  q_dir$=TURBO_DUMMY$("Directory",,"Print the directory:",42,20,10,col1%)
3450 END DEFine
3460 :
3470 DEFine PROCedure ch_ex
3480   POKE_L vadr1,adrrd_str
3490   q_ext$=TURBO_DUMMY$("Tailored EXT",,"Print up to 6 characters:",6,20,10,col1%)
3500 END DEFine
3510 :
3520 DEFine PROCedure Set_PosCol
3530  IF flnme$<>"":RETurn
3540  POKE_L vadr2,adrit_sel
3550  lines%=TURBO_DUMMYF("Choose number of Lines","Press ESC for all","3 lines","4 lines","5 lines",20,10,col1%)
3560  IF lines%:lines%=lines%+2
3570  col2%=TURBO_DUMMYF("Choose Menu Colour (B = Black, W = White)","Press ESC for default - Green & B/W","1 Red & W/B","2 Red & B/W","3 Green & W/B",20,10,col1%)
3580  col1%=TURBO_DUMMYF("Choose Window Colour (B = Black, W = White)","Press ESC for default - Green & B/W","1 Red & W/B","2 Red & B/W","3 Green & W/B",20,10,col1%)
3590 END DEFine
3600 :
3610 REMark **********************************************************************
3620 REMark *    BASIC_INDEX%(a$) returns -12 if a$ is not in the Name List.     *
3630 REMark * BASIC_ADR(num%) returns the address of item num% in the Name List  *
3640 REMark *  if num% is in range and the Name is a machine code function or    *
3650 REMark *  procedure. Hence we can detect whether or not a specific routine  *
3660 REMark *                          is loaded.                                *
3670 REMark **********************************************************************
3680 :
3690 DEFine FuNction QM_Here
3700  IF NOT qm_set
3710   adrrd_str=BASIC_ADR(BASIC_INDEX%("READ_STRING$"))
3720   IF adrrd_str>0
3730    qm_set=1
3740    adrfl_sel=BASIC_ADR(BASIC_INDEX%("FILE_SELECT$"))
3750    adrit_sel=BASIC_ADR(BASIC_INDEX%("ITEM_SELECT"))
3760    adrsc_clr=BASIC_ADR(BASIC_INDEX%("SCRAP_CLEAR"))
3770    adrsc_put=BASIC_ADR(BASIC_INDEX%("SCRAP_PUT"))
3780    adrsc_len=BASIC_ADR(BASIC_INDEX%("SCRAP_LEN"))
3790    adrsc_typ=BASIC_ADR(BASIC_INDEX%("SCRAP_TYPE"))
3800    adrsc_get=BASIC_ADR(BASIC_INDEX%("SCRAP_GET$"))
3810    vadr1=TURBO_V("TURBO_DUMMY$")
3820    vadr2=TURBO_V("TURBO_DUMMYF")
3830    vadr3=TURBO_V("TURBO_DUMMYP")
3840   END IF
3850  END IF
3860  RETurn qm_set
3870 END DEFine
3880 :
3890 DEFine FuNction Fle_Sel$(a$,b$,c$,d$,lines%,x_wh%,y_wh%,col1%,col2%)
3900  POKE_L vadr1,adrfl_sel
3910  RETurn TURBO_DUMMY$(a$,b$,c$,d$,lines%,x_wh%,y_wh%,col1%,col2%)
3920 END DEFine
3930 :
3940 DEFine PROCedure quse
3950  LOCal a$(2)
3960  OPEN#20,con
3970  a$=INKEY$(#20,-1)
3980  CLOSE#20
3990 END DEFine
4000 :
4010 DEFine FuNction Do_NoQM$
4020  LOCal a$(42)
4030  PAPER#4,WHITE%:CLS#4
4040  INK#4,BLACK%:PRINT#4,"Give the filename:"
4050  INK#4,RED%:AT#4,2,0
4060  a$=EDIT$(#4,"")
4070  RETurn a$
4080 END DEFine
4090 :
4100 REMark **********************************************************************
4110 REMark *    Scrp$ deals with certain filenames which activate the Scrap     *
4120 REMark *               Extensions if they are loaded.                       *
4130 REMark *                                                                    *
4140 REMark *  If Qmenu is not loaded, Scrp$ returns "No file picked" or "File   *
4150 REMark *  Picked". Otherwise the string returned and other actions taken    *
4160 REMark *              depend on the filename supplied.                      *
4170 REMark *                                                                    *
4180 REMark * Filename     Action                                                *
4190 REMark * scrap_inf    Length and Type of scrap is printed                   *
4200 REMark * scrap_set    Current filename is set to scrap                      *
4210 REMark * scrap_add    Current filename is added to scrap                    *
4220 REMark * scrap_prt    Current scrap is printed                              *
4230 REMark * scrap_clr    Scrap is cleared                                      *
4240 REMark *                                                                    *
4250 REMark *  The filename given can be upper or lower case. Any other string   *
4260 REMark *    than those shown here is treated as an ordinary filename.       *
4270 REMark **********************************************************************
4280 :
5000 DEFine FuNction Scrp$
5010  LOCal lp,num,b$(42)
5020  IF flnme$="":RETurn "No file picked"
5030  IF QM_Here
5040   IF NOT flnme$(1 TO 5)=="scrap":RETurn "File Picked"
5050   RESTORE 5250
5060   REPeat lp
5070    READ b$,num
5080    IF b$="":EXIT lp
5090    IF b$==flnme$:EXIT lp
5100   END REPeat lp
5110   nofl=1
5120   SELect ON num
5130    =1:RETurn TL$
5140    =2:ScrClr:RETurn "Scrap Cleared"
5150    =3:RETurn Set_Prt$("Scrap Contents")
5160    =4:ScSet 0:RETurn Set_Prt$("Scrap Set")
5170    =5:ScSet 1:RETurn Set_Prt$("Scrap Added")
5180    =6:nofl=0:RETurn "File Picked"
5190   END SELect
5200  ELSE
5210   RETurn "File Picked"
5220  END IF
5230 END DEFine
5240 :
5250 DATA "scrap_inf",1
5260 DATA "scrap_clr",2
5270 DATA "scrap_prt",3
5280 DATA "scrap_set",4
5290 DATA "scrap_add",5
5300 DATA "",6
5310 :
5320 DEFine FuNction TL$
5330  RETurn "Length = "&ScLen&CHR$(10)&"Type = "&ScTp
5340 END DEFine
5350 :
5360 DEFine FuNction ScSt$
5370  LOCal a$(40)
5380  a$=ScrGt$
5390  RETurn a$
5400 END DEFine
5410 :
5420 DEFine PROCedure ScrClr
5430  POKE_L vadr3,adrsc_clr
5440  TURBO_DUMMYP
5450 END DEFine
5460 :
5470 DEFine PROCedure ScSet(o%)
5480  POKE_L vadr3,adrsc_put
5490  TURBO_DUMMYP 0,ofln$,o%
5500 END DEFine
5510 :
5520 DEFine FuNction ScrGt$
5530  POKE_L vadr1,adrsc_get
5540  RETurn TURBO_DUMMY$
5550 END DEFine
5560 :
5570 DEFine FuNction ScLen
5580  POKE_L vadr2,adrsc_len
5590  RETurn TURBO_DUMMYF
5600 END DEFine
5610 :
5620 DEFine FuNction ScTp
5630  POKE_L vadr2,adrsc_typ
5640  RETurn TURBO_DUMMYF
5650 END DEFine
5660 :
5670 DEFine FuNction Set_Prt$(a$)
5680  nofl=2
5690  flnme$=ScSt$
5700  IF flnme$="":RETurn "No File Picked":ELSE RETurn a$
5710 END DEFine
5720 :
5730 DEFine PROCedure g_mxw
5740  REMark To set max_x% & max_y%
5750  LOCal mxx
5760  mxx=W_MAX:_max_x%=get_x%(mxx):_max_y%=get_y%(mxx)
5770 END DEFine
5780 :
17000 REMark ********************************************************
17010 REMark * Before compilation, we have to arrange for tptr_bas  *
17020 REMark * to be added. We also need to be sure that the window *
17030 REMark * definition will be included at lines 19600.          *
17040 REMark * Finally, we can cut down the size of the program by  *
17050 REMark * deleting some unnecessary routines in tptr_bas.      *
17060 REMark *                                                      *
17070 REMark * 1. The routine Mr will merge tptr_bas.               *
17080 REMark * 2. The window definition is added by the routine Mw. *
17090 REMark * 3. The routine St deletes the routines in tptr_bas   *
17100 REMark *    for producing  sprites and producing an app menu. *
17110 REMark *                                                      *
17120 REMark * Once Ex5_bas is loaded, pressing Mr, Mw, St, Charge  *
17130 REMark * will cause compilation.                              *
17140 REMark *                                                      *
17150 REMark * Note the use of DEBUG 1 and DEBUG 0 to prevent       *
17160 REMark * compilation of the lines between them.               *
17170 REMark ********************************************************
17180 :
18000 DEBUG 1
18010 DEFine PROCedure Mr
18020  TYPE_IN "MERGE win1_qptr_basic_tptr_bas"&CHR$(10)
18030 END DEFine
18040 :
18050 DEFine PROCedure Mw
18060  TYPE_IN "MERGE win1_qptr_basic_EX5_WDA"&CHR$(10)
18070 END DEFine
18080 :
18090 DEFine PROCedure st
18100  Remov "Sprite Menu"
18110 END DEFine
18120 :
18130 DEFine PROCedure ss
18140  SAVE win1_qptr_basic_Ex5_bas,2 TO 19599
18150 END DEFine
18160 :
18170 DEBUG 0
